# --------------------------------------------------------------------

# Define server logic  ----

server <- function(input, output, session) {
  
 library(shinyjqui)
  library(shiny)  
  
  jqui_draggable(ui = "#runtgrafen")
  jqui_draggable(ui = "#info")
  jqui_draggable(ui = "#kommentarer")
  jqui_draggable(ui = "#ovningar")
  jqui_resizable(ui = ".infoyta")

 observe({
  
   Xkoeff <- input$Xkoeff; 
   Ykoeff <- input$Ykoeff; 

   X2koeff <- input$X2koeff; 
   Y2koeff <- input$Y2koeff; 

   XYkoeff <- input$XYkoeff; 
   
   thetavinkel <- input$thetavinkel; 
   phivinkel   <- input$phivinkel; 

   output$grafen <- renderPlot({
  
   EnYta <- function(X, Y){ 52.7 + Xkoeff*X + Ykoeff*Y + X2koeff*X**2 + Y2koeff*Y**2 + XYkoeff*X*Y}

Xled <- seq(-3, 3, length = 20)
Yled <- seq(-3, 3, length = 20)
Zled <- outer(Xled, Yled, EnYta)

persp(Xled, Yled, Zled,
main  = 'Linjär modell med första- och andragradstermer',
zlab  = 'Höjd',
theta = thetavinkel, phi = phivinkel,
col   = 'yellow', shade = 0.5)

 })
 
})  

ovn <- 1

observeEvent(input$reset, {
if (ovn == 1) {
  updateSliderInput(inputId = "Xkoeff", value = -2.1)
  updateSliderInput(inputId = "Ykoeff", value = 2.6)
  updateSliderInput(inputId = "X2koeff", value = 2.2)
  updateSliderInput(inputId = "Y2koeff", value = 2.8)
  updateSliderInput(inputId = "XYkoeff", value = 2.1)
  updateSliderInput(inputId = "thetavinkel", value = 30)
  updateSliderInput(inputId = "phivinkel", value = 14)
} 
})

observeEvent(input$ovn1a, {
  infotext <- "Övning 1a"
    updateSliderInput(inputId = "Xkoeff", value = -2.1)
    updateSliderInput(inputId = "Ykoeff", value = 0)
    updateSliderInput(inputId = "X2koeff", value = 0)
    updateSliderInput(inputId = "Y2koeff", value = 0)
    updateSliderInput(inputId = "XYkoeff", value = 0)
    updateSliderInput(inputId = "thetavinkel", value = 0)
    updateSliderInput(inputId = "phivinkel", value = 0)
})

observeEvent(input$ovn1b, {
  updateSliderInput(inputId = "Xkoeff", value = -2.1)
  updateSliderInput(inputId = "Ykoeff", value = 0)
  updateSliderInput(inputId = "X2koeff", value = 1.9)
  updateSliderInput(inputId = "Y2koeff", value = 0)
  updateSliderInput(inputId = "XYkoeff", value = 0)
  updateSliderInput(inputId = "thetavinkel", value = 0)
  updateSliderInput(inputId = "phivinkel", value = 0)
})
observeEvent(input$ovn2, {
  updateSliderInput(inputId = "Xkoeff", value = -2.1)
  updateSliderInput(inputId = "Ykoeff", value = 2.6)
  updateSliderInput(inputId = "X2koeff", value = 0)
  updateSliderInput(inputId = "Y2koeff", value = 0)
  updateSliderInput(inputId = "XYkoeff", value = 0)
  updateSliderInput(inputId = "thetavinkel", value = 30)
  updateSliderInput(inputId = "phivinkel", value = 14)
})

observeEvent(input$ovn3, {
  updateSliderInput(inputId = "Xkoeff", value = -2.1)
  updateSliderInput(inputId = "Ykoeff", value = 2.6)
  updateSliderInput(inputId = "X2koeff", value = 2.2)
  updateSliderInput(inputId = "Y2koeff", value = 0)
  updateSliderInput(inputId = "XYkoeff", value = 0)
  updateSliderInput(inputId = "thetavinkel", value = 30)
  updateSliderInput(inputId = "phivinkel", value = 14)
})


observeEvent(input$ovn4, {
  updateSliderInput(inputId = "Xkoeff", value = -2.1)
  updateSliderInput(inputId = "Ykoeff", value = 2.6)
  updateSliderInput(inputId = "X2koeff", value = 0)
  updateSliderInput(inputId = "Y2koeff", value = 4.2)
  updateSliderInput(inputId = "XYkoeff", value = 0)
  updateSliderInput(inputId = "thetavinkel", value = 30)
  updateSliderInput(inputId = "phivinkel", value = 14)
})

observeEvent(input$ovn5, {
  updateSliderInput(inputId = "Xkoeff", value = -2.1)
  updateSliderInput(inputId = "Ykoeff", value = 2.6)
  updateSliderInput(inputId = "X2koeff", value = 0)
  updateSliderInput(inputId = "Y2koeff", value = 0)
  updateSliderInput(inputId = "XYkoeff", value = -3.5)
  updateSliderInput(inputId = "thetavinkel", value = 30)
  updateSliderInput(inputId = "phivinkel", value = 14)
})

observeEvent(input$ovn6, {
  updateSliderInput(inputId = "Xkoeff", value = -2.1)
  updateSliderInput(inputId = "Ykoeff", value = 2.6)
  updateSliderInput(inputId = "X2koeff", value = 2.7)
  updateSliderInput(inputId = "Y2koeff", value = 4.1)
  updateSliderInput(inputId = "XYkoeff", value = 0)
  updateSliderInput(inputId = "thetavinkel", value = 30)
  updateSliderInput(inputId = "phivinkel", value = 14)
})

observeEvent(input$ovn7, {
  updateSliderInput(inputId = "Xkoeff", value = -2.1)
  updateSliderInput(inputId = "Ykoeff", value = 2.6)
  updateSliderInput(inputId = "X2koeff", value = 2.7)
  updateSliderInput(inputId = "Y2koeff", value = 4.1)
  updateSliderInput(inputId = "XYkoeff", value = -3.5)
  updateSliderInput(inputId = "thetavinkel", value = 30)
  updateSliderInput(inputId = "phivinkel", value = 14)
})

}
